#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"

int ML_ItemIsHavePDF(EPM_action_message_t msg)
{
	printf("=========================校验版本下是否包含PDF数据集 Start===================\n");
	auto startTime = std::chrono::high_resolution_clock::now();
	int ifail = ITK_ok;
	int  attachments_num = 0;
	tag_t  rootTask = NULLTAG, *attachments = NULLTAG;
	//获取任务对象
	EPM_ask_root_task(msg.task, &rootTask);
	//获取任务目标对象
	EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments);

	char *argflag = NULL, *argvalue = NULL, *arg = NULL;
	char arg1value[1024] = "", arg2value[1024] = "";
	//获取参数
	int arg_cnt = TC_number_of_arguments(msg.arguments);
	printf("参数个数为：%d\n", arg_cnt);
	if (arg_cnt > 0)
	{
		for (int i = 0; i<arg_cnt; i++)
		{
			//获取下一个参数（从0开始）
			arg = TC_next_argument(msg.arguments);
			//获取参数的名称和值
			ifail = ITK_ask_argument_named_value((const char*)arg, &argflag, &argvalue);
			if (stricmp(argflag, "itemType") == 0)
			{
				//strcmp("","");
				if (argvalue != NULL)
				{
					strcpy(arg1value, argvalue);
				}
			}
			else if (stricmp(argflag, "referenced") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(arg2value, argvalue);
				}
			}
		}
		DOFREE(argflag);
		DOFREE(argvalue);
		DOFREE(arg);
	}

	vector<char *> itemTypeValues;

	if (strstr(arg1value, ",") != NULL)
	{
		int vectorValueCount = 0;
		char ** vectorValueChar = new char *[64];
		split(arg1value, ",", vectorValueChar, &vectorValueCount);
		for (int i = 0; i < vectorValueCount; i++)
		{
			itemTypeValues.push_back(vectorValueChar[i]);
		}
	}
	else
	{
		itemTypeValues.push_back(arg1value);
	}

	char resultString[2048] = "";

	for (int i = 0; i < attachments_num; i++)
	{
		char *itemType = NULL;

		AOM_ask_value_string(attachments[i], "object_type", &itemType);
		printf("type_class : %s \r\n", itemType);
		//过滤掉非文件夹的对象
		if (!count(itemTypeValues, itemType))
		{
			DOFREE(itemType);
			continue;
		}
		int num = 0;
		tag_t * tags = NULLTAG;
		AOM_ask_value_tags(attachments[i], arg2value, &num, &tags);
		bool isHave = false;
		for (int j = 0; j < num; j++)
		{
			char *dataSetType = NULL;

			AOM_ask_value_string(tags[j], "object_type", &dataSetType);
			if (strcmp(dataSetType, "PDF") == 0)
			{
				isHave = true;
				DOFREE(dataSetType);
				break;
			}
			DOFREE(dataSetType);
		}
		if (!isHave)
		{
			ifail = 1;
			char *itemString = NULL;

			AOM_ask_value_string(attachments[i], "object_string", &itemString);

			strcat(resultString, itemString);
			strcat(resultString, "\n");
			DOFREE(itemString);

		}
		DOFREE(tags);
		DOFREE(itemType);
	}
	itemTypeValues.clear();
	vector<char *>().swap(itemTypeValues);
	DOFREE(attachments);
	if (ifail == 1)
	{
		strcat(resultString, "下不包含PDF文件！");
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, resultString);
	}

	auto stopTime = std::chrono::high_resolution_clock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(stopTime - startTime);
	//std::cout << "ML_ItemIsHavePDF用时:" << duration.count() / 1000 << std::endl;
	string usetime = "ML_ItemIsHavePDF用时:";
	usetime.append(std::to_string(duration.count() / 1000));
	WriteLog(true, usetime.c_str());
	printf("=========================校验版本下是否包含PDF数据集 End===================\n");
	return ifail;
}
